FIX: Print usage when config is not passed to launcher.
[discourse_docker.git] / launcher
CommitLineData
ace450bd 1#!/bin/bash
7e738616 2
5cb39519 3usage () {
c2d3ee4a 4 echo "Usage: launcher COMMAND CONFIG [--skip-prereqs] [--docker-args STRING]"
5cb39519 5 echo "Commands:"
1ec142a1
GXT
6 echo " start: Start/initialize a container"
7 echo " stop: Stop a running container"
8 echo " restart: Restart a container"
9 echo " destroy: Stop and remove a container"
10 echo " enter: Open a shell to run commands inside the container"
11 echo " logs: View the Docker logs for a container"
12 echo " bootstrap: Bootstrap a container for the config based on a template"
2791af60 13 echo " run: Run the given command with the config in the context of the last bootstrapped image"
1ec142a1
GXT
14 echo " rebuild: Rebuild a container (destroy old, bootstrap, start new)"
15 echo " cleanup: Remove all containers that have stopped for > 24 hours"
5cb39519
JA
16 echo
17 echo "Options:"
1f656469 18 echo " --skip-prereqs Don't check launcher prerequisites"
1f656469 19 echo " --docker-args Extra arguments to pass when running docker"
cad2919f 20 echo " --skip-mac-address Don't assign a mac address"
c786ffcd 21 echo " --run-image Override the image used for running the container"
5cb39519
JA
22 exit 1
23}
24
7e738616
S
25command=$1
26config=$2
65573a0e 27user_args=""
c786ffcd 28user_run_image=""
87c4f221 29
1ec142a1
GXT
30if [[ $command == "run" ]]; then
31 run_command=$3
32fi
33
1f656469 34while [ ${#} -gt 0 ]; do
65573a0e 35 case "${1}" in
19e3a6c0
S
36 --debug)
37 DEBUG="1"
38 ;;
1f656469 39 --skip-prereqs)
4f36bb43 40 SKIP_PREREQS="1"
1f656469 41 ;;
cad2919f
GXT
42 --skip-mac-address)
43 SKIP_MAC_ADDRESS="1"
44 ;;
1f656469
GXT
45 --docker-args)
46 user_args="$2"
47 shift
48 ;;
c786ffcd
GXT
49 --run-image)
50 user_run_image="$2"
51 shift
52 ;;
1f656469
GXT
53 esac
54
55 shift 1
56done
55d17203 57
f80e6a37
GXT
58if [[ -z $config ]]; then
59 usage
60 exit 1
61fi
62
87756d6d 63# Docker doesn't like uppercase characters, spaces or special characters, catch it now before we build everything out and then find out
abcf2a97 64re='[[:upper:]/ !@#$%^&*()+~`=]'
87756d6d
EH
65if [[ $config =~ $re ]];
66 then
8877f99e 67 echo
abcf2a97 68 echo "ERROR: Config name '$config' must not contain upper case characters, spaces or special characters. Correct config name and rerun $0."
87756d6d
EH
69 echo
70 exit 1
71fi
72
7936ebaa 73cd "$(dirname "$0")"
55d17203 74
0998a7c8 75docker_min_version='17.03.1'
ddf8c54c 76docker_rec_version='17.06.2'
6828238a
JP
77git_min_version='1.8.0'
78git_rec_version='1.8.0'
60668406 79
8dea575c 80config_file=containers/"$config".yml
5201a40c 81cidbootstrap=cids/"$config"_bootstrap.cid
5efded6a 82local_discourse=local_discourse
de92c66d 83image=discourse/base:2.0.20181031
4807b1b8 84docker_path=`which docker.io || which docker`
6828238a 85git_path=`which git`
8877f99e 86
e0fd1f5b
TB
87if [ "${SUPERVISED}" = "true" ]; then
88 restart_policy="--restart=no"
89 attach_on_start="-a"
90 attach_on_run="-a stdout -a stderr"
91else
92 attach_on_run="-d"
93fi
94
f2a3edee
AY
95if [ -n "$DOCKER_HOST" ]; then
96 docker_ip=`sed -e 's/^tcp:\/\/\(.*\):.*$/\1/' <<< "$DOCKER_HOST"`
97elif [ -x "$(which ip 2>/dev/null)" ]; then
813fef38 98 docker_ip=`ip addr show docker0 | \
03bb0735
LG
99 grep 'inet ' | \
100 awk '{ split($2,a,"/"); print a[1] }';`
101else
813fef38 102 docker_ip=`ifconfig | \
03bb0735
LG
103 grep -B1 "inet addr" | \
104 awk '{ if ( $1 == "inet" ) { print $2 } else if ( $2 == "Link" ) { printf "%s:" ,$1 } }' | \
105 grep docker0 | \
106 awk -F: '{ print $3 }';`
107fi
80c11be3 108
7a96c86d 109# From https://stackoverflow.com/a/44660519/702738
60668406 110compare_version() {
7a96c86d
RSS
111 if [[ $1 == $2 ]]; then
112 return 1
113 fi
114 local IFS=.
115 local i a=(${1%%[^0-9.]*}) b=(${2%%[^0-9.]*})
116 local arem=${1#${1%%[^0-9.]*}} brem=${2#${2%%[^0-9.]*}}
117 for ((i=0; i<${#a[@]} || i<${#b[@]}; i++)); do
118 if ((10#${a[i]:-0} < 10#${b[i]:-0})); then
60668406 119 return 1
7a96c86d
RSS
120 elif ((10#${a[i]:-0} > 10#${b[i]:-0})); then
121 return 0
60668406
DP
122 fi
123 done
7a96c86d
RSS
124 if [ "$arem" '<' "$brem" ]; then
125 return 1
126 elif [ "$arem" '>' "$brem" ]; then
127 return 0
128 fi
129 return 1
60668406
DP
130}
131
665468eb
JA
132
133install_docker() {
c2d3ee4a 134 echo "Docker is not installed, you will need to install Docker in order to run Launcher"
bf6d49b5 135 echo "See https://docs.docker.com/installation/"
665468eb
JA
136 exit 1
137}
138
87c4f221 139check_prereqs() {
794e44d5
GXT
140
141 if [ -z $docker_path ]; then
665468eb
JA
142 install_docker
143 fi
a3e18d95 144
e741295a 145 # 1. docker daemon running?
30835a52
S
146 # we send stderr to /dev/null cause we don't care about warnings,
147 # it usually complains about swap which does not matter
148 test=`$docker_path info 2> /dev/null`
e741295a
MB
149 if [[ $? -ne 0 ]] ; then
150 echo "Cannot connect to the docker daemon - verify it is running and you have access"
151 exit 1
152 fi
153
90287f8e 154 # 2. running an approved storage driver?
7644adb7 155 if ! $docker_path info 2> /dev/null | egrep -q '^Storage Driver: (aufs|btrfs|zfs|overlay|overlay2)$'; then
90287f8e 156 echo "Your Docker installation is not using a supported storage driver. If we were to proceed you may have a broken install."
7644adb7 157 echo "aufs is the recommended storage driver, although zfs/btrfs/overlay and overlay2 may work as well."
90287f8e
MP
158 echo "Other storage drivers are known to be problematic."
159 echo "You can tell what filesystem you are using by running \"docker info\" and looking at the 'Storage Driver' line."
5dfdf9a3 160 echo
90287f8e
MP
161 echo "If you wish to continue anyway using your existing unsupported storage driver,"
162 echo "read the source code of launcher and figure out how to bypass this check."
48f22d14 163 exit 1
a3e18d95
S
164 fi
165
60668406
DP
166 # 3. running recommended docker version
167 test=($($docker_path --version)) # Get docker version string
168 test=${test[2]//,/} # Get version alone and strip comma if exists
a3e18d95 169
87c4f221 170 # At least minimum docker version
cf00fce0 171 if compare_version "${docker_min_version}" "${test}"; then
60668406 172 echo "ERROR: Docker version ${test} not supported, please upgrade to at least ${docker_min_version}, or recommended ${docker_rec_version}"
a3e18d95
S
173 exit 1
174 fi
175
87c4f221 176 # Recommend newer docker version
60668406
DP
177 if compare_version "${docker_rec_version}" "${test}"; then
178 echo "WARNING: Docker version ${test} deprecated, recommend upgrade to ${docker_rec_version} or newer."
179 fi
180
405948ee
S
181 # 4. discourse docker image is downloaded
182 test=`$docker_path images | awk '{print $1 ":" $2 }' | grep "$image"`
183
184 if [ -z "$test" ]; then
185 echo
186 echo "WARNING: We are about to start downloading the Discourse base image"
187 echo "This process may take anywhere between a few minutes to an hour, depending on your network speed"
188 echo
189 echo "Please be patient"
190 echo
405948ee 191 fi
405948ee 192
6828238a
JP
193 # 5. running recommended git version
194 test=($($git_path --version)) # Get git version string
195 test=${test[2]//,/} # Get version alone and strip comma if exists
196
197 # At least minimum version
198 if compare_version "${git_min_version}" "${test}"; then
199 echo "ERROR: Git version ${test} not supported, please upgrade to at least ${git_min_version}, or recommended ${git_rec_version}"
200 exit 1
201 fi
202
203 # Recommend best version
204 if compare_version "${git_rec_version}" "${test}"; then
205 echo "WARNING: Git version ${test} deprecated, recommend upgrade to ${git_rec_version} or newer."
206 fi
207
208 # 6. able to attach stderr / out / tty
e02c1511 209 test=`$docker_path run $user_args -i --rm -a stdout -a stderr $image echo working`
a3e18d95
S
210 if [[ "$test" =~ "working" ]] ; then : ; else
211 echo "Your Docker installation is not working correctly"
212 echo
213 echo "See: https://meta.discourse.org/t/docker-error-on-bootstrap/13657/18?u=sam"
214 exit 1
215 fi
4770834b 216
49b2fcc4 217 # 7. enough space for the bootstrap on docker folder
8cdc533d
RSS
218 folder=`$docker_path info --format '{{.DockerRootDir}}'`
219 safe_folder=${folder:-/var/lib/docker}
49b2fcc4
RSS
220 test=$(($(stat -f --format="%a*%S" $safe_folder)/1024**3 < 5))
221 if [[ $test -ne 0 ]] ; then
da095c30
RSS
222 echo "You have less than 5GB of free space on the disk where $safe_folder is located. You will need more space to continue"
223 df -h $safe_folder
49b2fcc4
RSS
224 echo
225 read -p "Would you like to attempt to recover space by cleaning docker images and containers in the system?(y/N)" -n 1 -r
226 echo
227 if [[ $REPLY =~ ^[Yy]$ ]]
228 then
229 docker system prune
230 echo "If the cleanup was successful, you may try again now"
231 fi
232 exit 1
233 fi
6e784be6
MP
234}
235
6828238a 236
cf3dd6f2 237if [ -z "$SKIP_PREREQS" ] && [ "$command" != "cleanup" ]; then
87c4f221 238 check_prereqs
55d17203 239fi
a3e18d95 240
60f9f04c
S
241host_run() {
242 read -r -d '' env_ruby << 'RUBY'
243 require 'yaml'
244
245 input = STDIN.readlines.join
246 yaml = YAML.load(input)
247
248 if host_run = yaml['host_run']
249 params = yaml['params'] || {}
250 host_run.each do |run|
251 params.each do |k,v|
252 run = run.gsub("$#{k}", v)
253 end
254 STDOUT.write "#{run}--SEP--"
255 end
256 end
257RUBY
258
e02c1511 259 host_run=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e "$env_ruby"`
60f9f04c
S
260
261 while [ "$host_run" ] ; do
262 iter=${host_run%%--SEP--*}
263 echo
264 echo "Host run: $iter"
265 $iter || exit 1
266 echo
267 host_run="${host_run#*--SEP--}"
268 done
269}
270
271
d90671f3 272set_volumes() {
e02c1511 273 volumes=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e \
02d9a654 274 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['volumes'].map{|v| '-v ' << v['volume']['host'] << ':' << v['volume']['guest'] << ' '}.join"`
d90671f3
SS
275}
276
41daa523 277set_links() {
e02c1511 278 links=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e \
41daa523 279 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['links'].map{|l| '--link ' << l['link']['name'] << ':' << l['link']['alias'] << ' '}.join"`
280}
281
06310c73
GXT
282find_templates() {
283 local templates=`cat $1 | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
7f77c274
SS
284 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['templates']"`
285
06310c73
GXT
286 local arrTemplates=${templates// / }
287
2ec550f7 288 if [ ! -z "$templates" ]; then
06310c73
GXT
289 for template in "${arrTemplates[@]}"
290 do
291 local nested_templates=$(find_templates $template)
292
293 if [ ! -z "$nested_templates" ]; then
294 templates="$templates $nested_templates"
295 fi
296 done
297
298 echo $templates
299 else
300 echo ""
301 fi
302}
303
304set_template_info() {
305 templates=$(find_templates $config_file)
306
7f77c274
SS
307 arrTemplates=(${templates// / })
308 config_data=$(cat $config_file)
309
310 input="hack: true"
311
7f77c274
SS
312 for template in "${arrTemplates[@]}"
313 do
314 [ ! -z $template ] && {
315 input="$input _FILE_SEPERATOR_ $(cat $template)"
316 }
317 done
318
319 # we always want our config file last so it takes priority
320 input="$input _FILE_SEPERATOR_ $config_data"
321
322 read -r -d '' env_ruby << 'RUBY'
323 require 'yaml'
324
325 input=STDIN.readlines.join
093e6628 326 # default to UTF-8 for the dbs sake
3cb3d9c4 327 env = {'LANG' => 'en_US.UTF-8'}
7f77c274
SS
328 input.split('_FILE_SEPERATOR_').each do |yml|
329 yml.strip!
330 begin
331 env.merge!(YAML.load(yml)['env'] || {})
f3824347 332 rescue Psych::SyntaxError => e
333 puts e
334 puts "*ERROR."
7f77c274
SS
335 rescue => e
336 puts yml
337 p e
338 end
339 end
4b563ee8 340 puts env.map{|k,v| "-e\n#{k}=#{v}" }.join("\n")
7f77c274
SS
341RUBY
342
fb827907
EP
343 tmp_input_file=$(mktemp)
344
345 echo "$input" > "$tmp_input_file"
346 raw=`exec cat "$tmp_input_file" | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e "$env_ruby"`
347
348 rm -f "$tmp_input_file"
4b563ee8
SS
349
350 env=()
f3824347 351 ok=1
4b563ee8 352 while read i; do
f3824347 353 if [ "$i" == "*ERROR." ]; then
354 ok=0
355 elif [ -n "$i" ]; then
16f2d250
S
356 env[${#env[@]}]=$i
357 fi
4b563ee8
SS
358 done <<< "$raw"
359
f3824347 360 if [ "$ok" -ne 1 ]; then
361 echo "${env[@]}"
c2d3ee4a 362 echo "YAML syntax error. Please check your containers/*.yml config files."
f3824347 363 exit 1
364 fi
762d9bbf
MP
365
366 read -r -d '' labels_ruby << 'RUBY'
367 require 'yaml'
368
369 input=STDIN.readlines.join
370 # default to UTF-8 for the dbs sake
371 labels = {}
372 input.split('_FILE_SEPERATOR_').each do |yml|
373 yml.strip!
374 begin
375 labels.merge!(YAML.load(yml)['labels'] || {})
376 rescue Psych::SyntaxError => e
377 puts e
378 puts "*ERROR."
379 rescue => e
380 puts yml
381 p e
382 end
383 end
384 puts labels.map{|k,v| "-l\n#{k}=#{v}" }.join("\n")
385RUBY
386
fb827907
EP
387 tmp_input_file=$(mktemp)
388
389 echo "$input" > "$tmp_input_file"
390 raw=`exec cat "$tmp_input_file" | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e "$labels_ruby"`
391
392 rm -f "$tmp_input_file"
762d9bbf
MP
393
394 labels=()
395 ok=1
396 while read i; do
397 if [ "$i" == "*ERROR." ]; then
398 ok=0
399 elif [ -n "$i" ]; then
daddbf86 400 labels[${#labels[@]}]=$(echo $i | sed s/{{config}}/${config}/g)
762d9bbf
MP
401 fi
402 done <<< "$raw"
403
404 if [ "$ok" -ne 1 ]; then
405 echo "${labels[@]}"
406 echo "YAML syntax error. Please check your containers/*.yml config files."
407 exit 1
408 fi
7f77c274
SS
409}
410
665468eb 411if [ -z $docker_path ]; then
52388b87 412 install_docker
665468eb 413fi
52388b87 414
de869404 415[ "$command" == "cleanup" ] && {
c692f743
L
416 echo
417 echo "The following command will"
418 echo "- Delete all docker images for old containers"
419 echo "- Delete all stopped and orphan containers"
420 echo
421 read -p "Are you sure (Y/n): " -n 1 -r && echo
422 if [[ $REPLY =~ ^[Yy]$ || ! $REPLY ]]
423 then
30835a52 424 space=$(df /var/lib/docker | awk '{ print $4 }' | grep -v Available)
29a35d1b 425 echo "Starting Cleanup (bytes free $space)"
30835a52 426
29a35d1b 427 STATE_DIR=./.gc-state scripts/docker-gc
30835a52 428
24b887f2
JP
429 rm -f shared/standalone/log/var-log/*.txt
430
29a35d1b
S
431 space=$(df /var/lib/docker | awk '{ print $4 }' | grep -v Available)
432 echo "Finished Cleanup (bytes free $space)"
30835a52 433
c692f743 434 else
30835a52 435 exit 1
c692f743 436 fi
2dfd2c6d
GXT
437
438 if [ -d /var/discourse/shared/standalone/postgres_data_old ]; then
439 echo
440 echo "Old PostgreSQL backup data cluster detected taking up $(du -hs /var/discourse/shared/standalone/postgres_data_old | awk '{print $1}') detected"
441 read -p "Would you like to remove it? (Y/n): " -n 1 -r && echo
442
443 if [[ $REPLY =~ ^[Yy]$ ]]; then
444 echo "removing old PostgreSQL data cluster at /var/discourse/shared/standalone/postgres_data_old..."
445 rm -rf /var/discourse/shared/standalone/postgres_data_old
446 else
447 exit 1
448 fi
449 fi
450
a8b66f98
L
451 exit 0
452}
5f803fb4 453
65573a0e
GXT
454if [ -z "$command" -a -z "$config" ]; then
455 usage
456fi
457
458if [ ! "$command" == "setup" ]; then
459 if [[ ! -e $config_file ]]; then
7e738616 460 echo "Config file was not found, ensure $config_file exists"
5dfdf9a3 461 echo
71680b16 462 echo "Available configs ( `cd containers && ls -dm *.yml | tr -s '\n' ' ' | awk '{ gsub(/\.yml/, ""); print }'`)"
7e738616 463 exit 1
65573a0e 464 fi
7e738616
S
465fi
466
e2ed1fb6
S
467docker_version=($($docker_path --version))
468docker_version=${test[2]//,/}
69545efd 469restart_policy=${restart_policy:---restart=always}
e2ed1fb6 470
30835a52 471set_existing_container(){
295e8f19 472 existing=`$docker_path ps -a | awk '{ print $1, $(NF) }' | grep " $config$" | awk '{ print $1 }'`
337a89aa
S
473}
474
665468eb 475run_stop() {
337a89aa 476
30835a52 477 set_existing_container
60f9f04c 478
30835a52 479 if [ ! -z $existing ]
337a89aa 480 then
30835a52
S
481 (
482 set -x
a9cba0fc 483 $docker_path stop -t 10 $config
30835a52 484 )
337a89aa 485 else
30835a52
S
486 echo "$config was not started !"
487 exit 1
488 fi
489}
337a89aa 490
8877f99e
S
491set_run_image() {
492 run_image=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
493 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['run_image']"`
494
c786ffcd
GXT
495 if [ -n "$user_run_image" ]; then
496 run_image=$user_run_image
497 elif [ -z "$run_image" ]; then
8877f99e
S
498 run_image="$local_discourse/$config"
499 fi
500}
501
502set_boot_command() {
503 boot_command=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
504 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['boot_command']"`
505
506 if [ -z "$boot_command" ]; then
507
508 no_boot_command=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
509 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['no_boot_command']"`
510
511 if [ -z "$no_boot_command" ]; then
512 boot_command="/sbin/boot"
513 fi
514 fi
515}
516
665468eb 517run_start() {
337a89aa 518
295e8f19
S
519 existing=`$docker_path ps | awk '{ print $1, $(NF) }' | grep " $config$" | awk '{ print $1 }'`
520 echo $existing
30835a52
S
521 if [ ! -z $existing ]
522 then
523 echo "Nothing to do, your container has already started!"
eac33309 524 exit 0
30835a52
S
525 fi
526
295e8f19 527 existing=`$docker_path ps -a | awk '{ print $1, $(NF) }' | grep " $config$" | awk '{ print $1 }'`
30835a52
S
528 if [ ! -z $existing ]
529 then
530 echo "starting up existing container"
531 (
532 set -x
533 $docker_path start $config
534 )
535 exit 0
536 fi
537
538 host_run
1f656469 539
afec9a51
GXT
540 ports=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e \
541 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['expose'].map{|p| \"-p #{p}\"}.join(' ')"`
542
8b617e6e
PG
543 docker_args=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e \
544 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['docker_args']"`
545
30835a52
S
546 set_template_info
547 set_volumes
548 set_links
8877f99e
S
549 set_run_image
550 set_boot_command
30835a52 551
c6dd6f9d
FB
552 # get hostname and settings from container configuration
553 for envar in "${env[@]}"
554 do
555 if [[ $envar == DOCKER_USE_HOSTNAME* ]] || [[ $envar == DISCOURSE_HOSTNAME* ]]
556 then
557 # use as environment variable
558 eval $envar
559 fi
560 done
561
30835a52 562 (
c834fdd1 563 hostname=`hostname -s`
c6dd6f9d
FB
564 # overwrite hostname
565 if [ "$DOCKER_USE_HOSTNAME" = "true" ]
566 then
567 hostname=$DISCOURSE_HOSTNAME
568 else
569 hostname=$hostname-$config
570 fi
571
a0606001
S
572 # we got to normalize so we only have allowed strings, this is more comprehensive but lets see how bash does first
573 # hostname=`$docker_path run $user_args --rm $image ruby -e 'print ARGV[0].gsub(/[^a-zA-Z-]/, "-")' $hostname`
574 # docker added more hostname rules
fd2e7637 575 hostname=${hostname//_/-}
a0606001 576
cad2919f
GXT
577
578 if [ -z "$SKIP_MAC_ADDRESS" ] ; then
579 mac_address="--mac-address $($docker_path run $user_args -i --rm -a stdout -a stderr $image /bin/sh -c "echo $hostname | md5sum | sed 's/^\(..\)\(..\)\(..\)\(..\)\(..\).*$/02:\1:\2:\3:\4:\5/'")"
580 fi
d2a86ee1 581
30835a52 582 set -x
27c21012 583 $docker_path run --shm-size=512m $links $attach_on_run $restart_policy "${env[@]}" "${labels[@]}" -h "$hostname" \
bf268008 584 -e DOCKER_HOST_IP="$docker_ip" --name $config -t $ports $volumes $mac_address $docker_args $user_args \
d2a86ee1 585 $run_image $boot_command
30835a52
S
586
587 )
588 exit 0
337a89aa
S
589
590}
591
2791af60
GXT
592run_run() {
593 set_template_info
594 set_volumes
595 set_links
596 set_run_image
597
598 unset ERR
599 (exec $docker_path run --rm --shm-size=512m $user_args $links "${env[@]}" -e DOCKER_HOST_IP="$docker_ip" -i -a stdin -a stdout -a stderr $volumes $run_image \
600 /bin/bash -c "$run_command") || ERR=$?
601
602 if [[ $ERR > 0 ]]; then
603 exit 1
604 fi
605}
606
607run_bootstrap() {
60f9f04c
S
608 host_run
609
680dd4ea
S
610 # Is the image available?
611 # If not, pull it here so the user is aware what's happening.
4807b1b8 612 $docker_path history $image >/dev/null 2>&1 || $docker_path pull $image
88126eba 613
680dd4ea 614 set_template_info
93149421 615
e02c1511 616 base_image=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
680dd4ea 617 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['base_image']"`
93149421 618
e02c1511 619 update_pups=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
680dd4ea 620 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['update_pups']"`
b9c7b50e 621
680dd4ea
S
622 if [[ ! X"" = X"$base_image" ]]; then
623 image=$base_image
624 fi
b9c7b50e 625
680dd4ea 626 set_volumes
41daa523 627 set_links
f126bcc6 628
680dd4ea 629 rm -f $cidbootstrap
d90671f3 630
680dd4ea
S
631 run_command="cd /pups &&"
632 if [[ ! "false" = $update_pups ]]; then
633 run_command="$run_command git pull &&"
634 fi
ca2ce907 635 run_command="$run_command /pups/bin/pups --stdin"
2162f1d4 636
680dd4ea 637 echo $run_command
b9c7b50e 638
b4ab14c2 639 unset ERR
fb827907
EP
640
641 tmp_input_file=$(mktemp)
642
643 echo "$input" > "$tmp_input_file"
644 (exec cat "$tmp_input_file" | $docker_path run --shm-size=512m $user_args $links "${env[@]}" -e DOCKER_HOST_IP="$docker_ip" --cidfile $cidbootstrap -i -a stdin -a stdout -a stderr $volumes $image \
b4ab14c2
S
645 /bin/bash -c "$run_command") || ERR=$?
646
fb827907
EP
647 rm -f "$tmp_input_file"
648
b4ab14c2
S
649 unset FAILED
650 # magic exit code that indicates a retry
651 if [[ "$ERR" == 77 ]]; then
382c8e40
S
652 $docker_path rm `cat $cidbootstrap`
653 rm $cidbootstrap
b4ab14c2 654 exit 77
382c8e40 655 elif [[ "$ERR" > 0 ]]; then
b4ab14c2
S
656 FAILED=TRUE
657 fi
19e3a6c0
S
658
659 if [[ $FAILED = "TRUE" ]]; then
660 if [[ ! -z "$DEBUG" ]]; then
661 $docker_path commit `cat $cidbootstrap` $local_discourse/$config-debug || echo 'FAILED TO COMMIT'
662 echo "** DEBUG ** Maintaining image for diagnostics $local_discourse/$config-debug"
663 fi
88126eba 664
19e3a6c0
S
665 $docker_path rm `cat $cidbootstrap`
666 rm $cidbootstrap
667 echo "** FAILED TO BOOTSTRAP ** please scroll up and look for earlier error messages, there may be more than one"
668 exit 1
669 fi
9fb5f2d3 670
680dd4ea 671 sleep 5
2162f1d4 672
4807b1b8
MB
673 $docker_path commit `cat $cidbootstrap` $local_discourse/$config || echo 'FAILED TO COMMIT'
674 $docker_path rm `cat $cidbootstrap` && rm $cidbootstrap
680dd4ea 675}
9fb5f2d3 676
8877f99e
S
677
678
680dd4ea
S
679case "$command" in
680 bootstrap)
680dd4ea 681 run_bootstrap
2dd2e330 682 echo "Successfully bootstrapped, to startup use ./launcher start $config"
4b3aebe1 683 exit 0
5f803fb4 684 ;;
1acce9e4 685
1ec142a1
GXT
686 run)
687 run_run
688 exit 0
689 ;;
690
2fc6ff36 691 enter)
0c456e8c 692 exec $docker_path exec -it $config /bin/bash --login
2fc6ff36
S
693 ;;
694
5f803fb4 695 stop)
337a89aa
S
696 run_stop
697 exit 0
5f803fb4 698 ;;
7e738616 699
5f803fb4 700 logs)
7e738616 701
30835a52
S
702 $docker_path logs $config
703 exit 0
5f803fb4 704 ;;
7e738616 705
337a89aa
S
706 restart)
707 run_stop
708 run_start
709 exit 0
710 ;;
80c11be3 711
337a89aa
S
712 start)
713 run_start
714 exit 0
5f803fb4 715 ;;
7e738616 716
680dd4ea 717 rebuild)
4b6456ef 718 if [ "$(git symbolic-ref --short HEAD)" == "master" ]; then
c2d3ee4a 719 echo "Ensuring launcher is up to date"
098533cb
S
720
721 git remote update
722
723 LOCAL=$(git rev-parse @)
724 REMOTE=$(git rev-parse @{u})
725 BASE=$(git merge-base @ @{u})
726
727 if [ $LOCAL = $REMOTE ]; then
c2d3ee4a 728 echo "Launcher is up-to-date"
098533cb
S
729
730 elif [ $LOCAL = $BASE ]; then
c2d3ee4a 731 echo "Updating Launcher"
098533cb 732 git pull || (echo 'failed to update' && exit 1)
88ee2e35 733
8100fab0
PD
734 for (( i=${#BASH_ARGV[@]}-1,j=0; i>=0,j<${#BASH_ARGV[@]}; i--,j++ ))
735 do
736 args[$j]=${BASH_ARGV[$i]}
737 done
738 exec /bin/bash $0 "${args[@]}" # $@ is empty, because of shift at the beginning. Use BASH_ARGV instead.
098533cb
S
739
740 elif [ $REMOTE = $BASE ]; then
c2d3ee4a 741 echo "Your version of Launcher is ahead of origin"
098533cb
S
742
743 else
c2d3ee4a 744 echo "Launcher has diverged source, this is only expected in Dev mode"
098533cb
S
745 fi
746
4b6456ef 747 fi
30835a52
S
748
749 set_existing_container
750
751 if [ ! -z $existing ]
680dd4ea
S
752 then
753 echo "Stopping old container"
30835a52
S
754 (
755 set -x
756 $docker_path stop -t 10 $config
757 )
680dd4ea
S
758 fi
759
760 run_bootstrap
761
30835a52 762 if [ ! -z $existing ]
680dd4ea 763 then
30835a52
S
764 echo "Removing old container"
765 (
766 set -x
767 $docker_path rm $config
768 )
680dd4ea
S
769 fi
770
771 run_start
772 exit 0
773 ;;
774
7e738616 775
5f803fb4 776 destroy)
98bd0edf 777 (set -x; $docker_path stop -t 10 $config && $docker_path rm $config) || (echo "$config was not found" && exit 0)
30835a52 778 exit 0
5f803fb4
SS
779 ;;
780esac
7e738616 781
5f803fb4 782usage